;----------------------------------------
;     BUMP PROGRAM  FOR 1571 DISK DRIVE
;     1985.6.7
;     BY S.TOKUNAGA
;     COMMODORE JAPAN LIMITED
;----------------------------------------
;     EQU
;----------------------------------------
DSKCNT = $1C00
POTA1 = $180F
;----------------------------------------
;
 * = $400
;----------------------------------------
;    OUTPUT : (0000)=STATUS 01:O.K, 02:ERR
;----------------------------------------
BUMP
 SEI
 LDX #1
 STX CNTR ; COUNTER SET
B0
 LDA #16 ; TRACK 16 SEEK
 STA $6
 LDA #$B0 ; SEEK COMMAND
 STA $0
 CLI
B1
 LDA  $0 ; STATUS LOAD
 BMI B1
;
 SEI
 JSR DRV ; PULSE MOTOR DRIVE
 BCS B2 ; ERROR
 LDX CNTR
 DEX ; COUNTER -1
 STX CNTR
 BNE B0
;
 LDA #1 ; STATUS O.K
B3
 STA $0 ; STATUS STORE
 SEI
 RTS
;
B2
 LDA #2 ; STATUS ERROR
 BNE B3 ; JMP
;
;
;----------------------------------------
;   PULSE MOTOR DRIVE -(30+4*15) PULSE
;   OUTPUT : CARRY=0 : O.K , =1 : ERROR
;----------------------------------------
;
DRV
 LDA DSKCNT ; PHASE LOAD
 ORA #4 ; SPINDL MOTOR ON
 STA DSKCNT
;
 LDX #90 ; PULSE SET
D0
 JSR CCW ; NEXT PHASE SET
 JSR TIM ; TIMER 15MS
 DEX ; PULSE COUNT
 BNE D0
;
;
 LDA POTA1 ; PHOTO SENSOR IN
 ROR A
 RTS
;
;
;----------------------------------------
;   PULSE MOTOR NEXT PHASE SET
;   PHASE D - C - B - A
;----------------------------------------
;
CCW
 LDY DSKCNT ; PHASE LOAD
 DEY
 TYA
 AND #3
;
 STA TMP ; SAVE
 LDA DSKCNT ; PHASE LOAD
 AND #%11111100 ; BIT0,1=0
 ORA TMP ; NEXT PHASE SET
 STA DSKCNT
 RTS
;
;
;----------------------------------------
;   TIMER 15MS
;----------------------------------------
;
TIM
 TXA
 PHA ; X SAVE
 TYA
 PHA ; Y SAVE
;
 LDY #15
TM0
 JSR TIMS ; 1 MS
 DEY
 BNE TM0
;
 PLA
 TAY ; Y RETURN
 PLA
 TAX ; X RETURN
 RTS
;
;
;
;----------------------------------------
;   TIMER 1MS
;----------------------------------------
;
TIMS
 LDX #1
 CLC ; CARRY RESET
 LDA #200 ; 2
T10
 SBC #1 ; 2 CLOCK
 BNE T10 ; 2+1 CLOCK
 DEX ; 2
 BNE T10 ; 2+1
 RTS ; 6
;
;
;
;----------------------------------------
;   WORK AREA
;----------------------------------------
;
TMP .BYTE 0
CNTR .BYTE 0
;
;
;----------------------------------------
;
 .END
