; PROG. NAME 1571CR BURN IN ; PROG. NO.CETL0XX REV 1.0.0
; PROG. BY C.L.FANG CETL     NOV.24.1986
;
;---------- UPDATE LIST ----------
;
; REV 1.0.0 : MODIFY 1571 BURN IN TO 1571CR 
;           : WD 1770, 6526 DELETED, FDC 5710 ADDED 
;
;---------- INITIALIZE ----------
;
 *=$0400
;
START SEI
 CLD
;
 LDA #$0C ; MOTOR=OUT & LED=OUT
 ORA $1C02
 STA $1C02
;
 LDA #$F3 ; MOTOR OFF & LED OFF
 AND $1C00
 STA $1C00
;
;---------- RAM READ/WRITE ----------
;
 LDA #$55 ;CODE SET UP
 STA CODE
;
J010 LDX #0
J015 LDA CODE
 STA $0300,X
 STA $0700,X
;
 LDA CODE
 CMP $0300,X
 BNE RAMERR ;RAM ERROR
 CMP $0700,X
 BNE RAMERR ;RAM ERROR
 INX
 BNE J015 ;LOOP
;
 LDA CODE ;CODE CHECK
 CMP #$55 ;$55 ?
 BEQ J020 ;YES
 LDA #$55 ;NO
 JMP J030
J020 LDA #$AA
J030 STA CODE ;CODE SET
 JMP ROM
RAMERR JMP J100
;
;---------- ROM CHECKSUM ----------
;
ROM    LDA #$00   ; CHECKSUM RESULT CLEAR
 STA RSUML
 STA RSUMH
 LDA #$80
 STA J050+2
 LDX #$00
;
J050   LDA $8000,X    ; ADC ROM DATA $8000-$FFFF
 CLC
 ADC RSUML
 STA RSUML
 LDA #$00
 ADC RSUMH
 STA RSUMH
 INX
 BNE J050   ; IF ADLSL=$00 THEN INC(ADRSH)
 LDA #$01
 CLC
 ADC J050+2
 STA J050+2
 BNE J050   ; IF ADRSH=$00 THEN END
;
 LDA MSUML  ; COMPARE MASTER:RESULT
 CMP RSUML
 BNE ROMERR
 LDA MSUMH
 CMP RSUMH
 BNE ROMERR
 JMP FDC
ROMERR JMP J110
;
;---------- FDC5710 REGISTOR READ/WRITE ----------
;
FDC 
 JSR FDC0 ;STORE ORIGINAL VALUE OF REGISTERS
 JSR FDC006 ;TEST 2000,2001,2003-2005
 LDA #$40 ;TEST 400E
 STA $400E
 LDY #1
 LDA #$0F
 JSR DUMMY+2
 BIT $400E
 BVC FDCERR
 LDA #0
 STA $400E
 LDY #1
 LDA #$0F
 JSR DUMMY+2
 BIT $400E
 BVS FDCERR
 JSR SRAM ;TEST 8X8 SCRATCH PAD RAM (4010-4017)
 LDX #5 ;RESTORE REGISTERS CONTENTS
FD LDA MFMORG,X
 STA $2000,X
 DEX
 BPL FD
 LDA CODE
 JMP VIA901
FDCERR JMP J070
;
;
FDC0 LDX #5
FDC005 LDA $2000,X
 STA MFMORG,X
 DEX
 BPL FDC005
 RTS
;
FDC006 JSR FDC01
FDC01 LDA CODE 
 EOR #$FF
 STA CODE
FDC1 LDX #0
FDC2 LDA CODE
 AND PAT,X
 STA VALUE
 STA $2000,X
 LDY #1
 LDA #$0F
 JSR DUMMY+2
 CPX #2
 BEQ FDC3
 LDA $2000,X
 AND PAT,X
 CMP VALUE
 BNE FDCERR
FDC3 INX
 CPX #6
 BNE FDC2
 LDA #0 ;WBYTE BIT CHECK
 STA $2000
 BIT $2000
 BMI FDCERR
 LDA #$20 ;CERR BIT CHECK
 STA $2001
 LDA $2001
 AND #$20 
 BNE FDCERR
 RTS
;
SRAM JSR SRAM1
SRAM1 LDA CODE
 EOR #$FF
 STA CODE
 LDX #0
SRAM2 LDA CODE
 STA $4010,X
 LDY #1
 LDA #$0F
 JSR DUMMY+2
 LDA $4010,X
 CMP CODE
 BNE FDCERR
 INX
 CPX #8
 BNE SRAM2
 RTS
;
;
;----- 6522 (U09) REG. READ/WRITE ----------
;
VIA901 STA $1804   ; CHECK $1805 < TIMER 1 REG. >
 STA $1805
 CMP $1805
 BNE VIA9ER
;
 LDX #$06
VIA904 STA $1800,X ; CHECK $1806-$1807
 CMP $1800,X
 BNE VIA9ER
 INX
 CPX #$08
 BNE VIA904
;
 LDA #$00    ; ONE SHOT MODE TIMER 2
 STA $180B
 LDA CODE    ; CHECK $1809 < TIMER 2 REG. >
 STA $1808
 STA $1809
 CMP $1809
 BNE VIA9ER
;
 LDX #$0A    ; CHECK $180A-$180C
VIA905 STA $1800,X   ; < SR,ACR,PCR >
 CMP $1800,X
 BNE VIA9ER
 INX
 CPX #$0D
 BNE VIA905
;
 JMP VIA401
VIA9ER JMP J080
;
;----- 6522 (U04) REG. READ/WRITE ----------
;
VIA401 STA $1C04     ; CHECK $1C05 < TIMER 1 REG. >
 STA $1C05
 CMP $1C05
 BNE VIA4ER
;
 LDX #$06
VIA404 STA $1C00,X ; CHECK $1C06-$1C07
 CMP $1C00,X
 BNE VIA4ER
 INX
 CPX #$08
 BNE VIA404
;
 LDA #$00     ; ONE SHOT MODE TIMER 2
 STA $1C0B
 LDA CODE     ; CHECK $1C09 < TIMER 2 REG. >
 STA $1C08
 STA $1C09
 CMP $1C09
 BNE VIA4ER
;
 LDX #$0A     ; CHECK $1C0A-$1C0C
VIA405 STA $1C00,X
 CMP $1C00,X
 BNE VIA4ER
 INX
 CPX #$0D
 BNE VIA405
;
;---------- RAM/ ROM/ CONTOROLLER OK -----
;
 LDX #$01
 STX RESULT
 JSR FLICK
 JMP J010 ; RESTART BURN-IN
;
VIA4ER JMP J090
;
;---------- ERROR CODE TABLE ----------
;
J060 LDX #7 ;WD1770(U11) ERROR
 JMP J130
J070 LDX #6 ;6526  (U20) ERROR
 JMP J130
J080 LDX #5 ;6522  (U09) ERROR
 JMP J130
J090 LDX #4 ;6522  (U04) ERROR
 JMP J130
J100 LDX #3 ;RAM   (U03) ERROR
 JMP J130
J110 LDX #2 ;ROM   (U02) ERROR
;
J130 STX RESULT ; SET ERROR CODE
LOOP JSR FLICK
 JMP LOOP ; KEEP ERROR CONDITION
;
;---------- FLICKER ----------
;
FLICK LDX RESULT
 INX
LEDOF  LDA #$F7 ; LED OF
 AND $1C00
 STA $1C00
 DEX
 BEQ J140 ; IF FLIKER=0 THEN END
;
 LDY #$01 ; SET LED OFF TIME
 JSR DUMMY
 LDA #$08 ; LED ON
 ORA $1C00
 STA $1C00
 LDY #$01 ; SET LED ON  TIME
 JSR DUMMY
 JMP LEDOF
;
J140   LDY #$04
 JSR DUMMY
 RTS
;
;---------- SUB.DUMMY ----------
;
DUMMY  LDA #$40 ; SET DUMMY COUNTER $4040
 STA DUMMYL
 STA DUMMYH
;
 SEC
J200   LDA DUMMYL
 SBC #$01
 STA DUMMYL
 LDA DUMMYH
 SBC #$00
 STA DUMMYH
 BNE J200
 DEY
 BNE DUMMY
 RTS
;
;---------- WORK AREA ----------
;
 *=$06F0
 CODE   *=*+1 ; RAM WRITE CODE
 ONOF   *=*+1 ; FLICKER RESULT
;
 RESULT *=*+1 ; CHECK RESULT
;
              ; $01=OK
              ; $02=ROM   (U02) ERROR
              ; $03=RAM   (U03) ERROR
              ; $04=6522  (U04) ERROR
              ; $05=6522  (U09) ERROR
              ; $06=6526  (U20) ERROR
              ; $07=WD1770(U11) ERROR
;
 RSUML  *=*+1 ; RESULT CHECKSUM LOW BYTE
 RSUMH  *=*+1 ; RESULT CHECKSUM HI  BYTE
 MSUML  *=*+1 ; MASTER CHECKSUM LOW BYTE
 MSUMH  *=*+1 ; MASTER CHECKSUM HI  BYTE
 DUMMYL *=*+1 ; DUMMY COUNTER   LOW BYTE
 DUMMYH *=*+1 ; DUMMY COUNTER   HI  BYTE
 VALUE  *=*+1 ; ANY VALUES
;
 PAT .BYTE $3F,$1F,$FF,$FF,$F0 ;READ/WRITE BIT MAP(2000-2001,2003-2005)  
 MFMORG *=*+6 ; 5710 REGISTER ORIGIN VALUE
  .END
 
