; PUT"@0:MFM-SFTER1.ASM"
;*******************************
;*                             *
;* DDDD    IIII   SSSS  KK  KK *
;* DD  DD   II   SS  SS KK KK  *
;* DD  DD   II   SS     KKKK   *
;* DD  DD   II    SSSS  KKK    *
;* DD  DD   II       SS KKKK   *
;* DD  DD   II   SS  SS KK KK  *
;* DDDD    IIII   SSSS  KK  KK *
;*                             *
;*******************************
;*                             *
;* TTTTTT EEEEEE  SSSS  TTTTTT *
;*   TT   EE     SS  SS   TT   *
;*   TT   EE     SS       TT   *
;*   TT   EEEE    SSSS    TT   *
;*   TT   EE         SS   TT   *
;*   TT   EE     SS  SS   TT   *
;*   TT   EEEEEE  SSSS    TT   *
;*                             *
;*******************************
.SKIP 3
;*******************************
;*                             *
;* SOFT ERROR TEST FOR SYSTEM  *
;*        MODEL 1571           *
;*                             *
;*          JTP-047            *
;*                             *
;*    ===  MFM FORMAT  ===     *
;*                             *
;*                             *
;*       RIMI MIYAJIMA         *
;*    COMMODORE JAPAN LTD.     *
;*         SEP/30 '85          *
;*                             *
;*******************************
;
;
;
; ***  ALL LOCATIONS ARE IN DOS MEMORY  ***
;
;
;
; JTP047 REV 1.0.0   SEP.30,1985   RIMI MIYAJIMA (CJL)
.PAGE 'DEC'
; *****  1571 SOFT ERROR TEST  *****
;
;
;
; === PROGRAM IS STARTED AT $406 ===
;
;
;
; ******************************
; *  DEFINITIONS AND EQUATES   *
; ******************************
;
;
;
; ***  WORK FOR TEMP  ***
*=$6F
WK1 *=*+1
WK2 *=*+1
WK3 *=*+1
;
; ***  EQUATES  ***
SWITCH=$3B ;INFORMATION FOR DOS
SECTR=$43 ;SECTOR
MFMSZH=$44 ;SECTOR SIZE HI
CMDTRK=$67 ;TRACK
;
MFMCMD=$1B0 ;STATUS
CMDBUF=$200 ;COMMAND BUFFER
MFMSZL=$271 ;SECTOR SIZE LO
CMDSIZ=$274 ;COMMAND SIZE
;
BUFL=$300 ;BUFFER USED FOR LOG
LOGSEC=15 ;LOG SECTOR
LOGTRK=39 ;LOG TRACK
ERRLIM=4 ;MAX # OF ERRORS ALLWD=ERRLIM*256
;
MAXTRK=80 ;TOTAL TRACKS (+1) ON DISK
;
WRITE=10  ;WRITE JOB CODE
READ=9   ;READ JOB CODE
FORMAT=8 ;FORMAT JOB CODE
;
; ***  I/O  ***
LEDPRT=$1C00 ;OUTPUT PORT FOR LED.
LED=$8 ;DRIVE LED
;
WDSTAT=$2000 ;WD STATUS REG
WDTRK=$2001 ;WD TRACK REG
WDSEC=$2002 ;WD SECTOR REG
WDDAT=$2003 ;WD DATA REG
.PAGE
; ***  DOS ROUTINES  ***
PRCMD=$BF4E ;CONTROLLER
;
STMTR=$8794 ;START MOTOR
WTMTR=$87B0 ;WAIT MOTOR
SEKE=$87BA ;SEEK
CVSTAT=$883C ;CONVERT STATUS
STRTWD=$884E ;START WD (SEND COMMAND TO WD)
WAITDN=$8861 ;WAIT FOR UNBUSY
SLOG=$892A ;SEEK LOGICAL
SELSID=$8954 ;SIDE SELECT
CMDONE=$89EF ;COMMAND ONE (BUMP)
;
JSLOWD=$A483 ;WAIT 40 USEC
;
TRNOFF=$F98F ;TURN OFF MOTOR
.PAGE
; ***  VALIABLE PASSED BY CPU  ***
*=$400
PASTYP *=*+1 ;PASS TYPE, R($89) W($8A),
  ;IF<128 THEN N=RD/WR PASS RATIO.
;
NUMPAS *=*+1 ;NUMBER OF PASSES
;
PATERN *=*+1 ;WRITE DATA PATTERN
;
NEWDSK *=*+1 ;BITS 7,6 AS FOLLOWS:
 ;1,1: NEW DISK, FMT RQD, 1ST WRT.
 ;0,1: OLD DISK, NEW RUN, ZERO LOG.
 ;0,0: OLD DISK, CONTINUATION RUN.
;
RNDTRK *=*+1 ;BITS 7,6 AS FOLLOWS:
 ;0,0: PURE SEQUENTIAL TRAK SEQNCE.
 ;1,0: PURE 'RANDOM' TRAK SEQUENCE.
 ;1,1: ALT 'RANDOM' / SEQENTIAL.
;
RESET *=*+1 ;BIT7=1: RESET SYSTEM WHEN DONE.
;
;
;
START=* ;START ADDRESS
.PAGE
; ***  LOCATIONS IN LOG BUFFER  ***
*=BUFL+2
TOTPAS *=*+2 ;TOTAL PASSES MADE
TOTERR *=*+2 ;TOTAL ERRORS MADE
TRKERR *=*+MAXTRK ;PIGEON HOLES OF ERRORS/TRACK
ERRTYP *=*+20 ;# OF ERRORS OF TYPE 0 TO 20
PAS100 *=*+1 ;PASSES/100
PASCNT *=*+1 ;COUNT OF PASSES <100
ERRTIM *=*+40 ;WHEN OCCURRED (PER 100 PASSES)
REVCNT *=*+10 ;TIMES EACH RECOVERY OCCURRED
BADFPC *=*+1 ;FIRST PASS RETRY COUNT
FPCARY *=*+MAXTRK ;PIGEON HOLES OF 1ST PASS ERRORS
;
;
;
; ***  ERROR CODES  ***
;
;   2 = SECTOR NOT FOUND
;   3 = NO ADDRESS MARK (NO SYNC)
;   7 = VERIFY ERROR
;   9 = HEADER BLOCK CHECK SUM ERROR
.PAGE
; ***  LED CODING  ***
;
;
;
;FAST CONTINUOUS BLINKING MEANS FORMATTING IN PROGRESS.
;
;SLOW CONTINUOUS BLINKING MEANS TEST IN PROGRESS.
;
;
;
;FAST BLINKING SEPARATED BY TIME DELAY MEANS:
;
; # OF BLINKS                MEANS
;
;    1             TEST COMPLETED (W/WO ERRORS).
;    2             EXCESSIVE (>5) 1ST PASS ERRORS.
;    3             LOG ACCESS FAILURE.
;    4             FORMATTING FAILLED.
.PAGE 'START'
; ***  START OF 1571 SOFT ERROR TEST  ***
;
;
*=START
SEI ;KILL INTERRUPT
BIT NEWDSK ;FORMATTING REQD?
BPL STARTA ;NO, START TEST.
;
;
;
LDA #%00100110 ;7 P=0 PARTIAL FORMAT
 ;6 I=0 INDEX MARK WRITTEN
 ;5 D=1 DOUBLE SIDE
 ;4 S=0 #SIDE
 ;3 /=0
 ;2 /=1
 ;1 /=1
 ;0 N=0 #DRIVE
STA SWITCH ;LET DOS KNOW INFORMATION
;
LDA #$80 ;7 M=1 MFM FLG
 ;6 T=0 SECTOR TABLE INCLUDED
 ;5-0 =0 LOGICAL STARTING SECTOR
STA CMDBUF+3 ;(CMDBUF+5 DEFALT=256BYTES SECTOR SIZE)
;
LDA #4
STA CMDSIZ ;COMMAND SIZE
;
LDA #FORMAT
JSR PRCMD ;CONTROLLER
;
LDA MFMCMD ;GET INFORMATION
CMP #2 ;OK ?
BCC STARTA
;
LDX #4
JMP BLINK ;FORMAT ERROR
;
;
;
STARTA JSR BUMPIT ;BUMP DRIVE.
LDX #1
STX FPASS ;FIRST PASS FLAG
LDA #0
STA PASALT ;INIT ALT RD/WR PASS FLAG.
LDY PASTYP ;PRELOAD 'NTH PASS WRITE' CNTR.
STY PASWRT
.PAGE 'MAIN'
; ***  DRIVER FOR ERROR TESTS AND PATTERN LOAD  ***
;
MAIN JSR FILRUP ;ZERO OUT LOG BUFFER.
;
BIT NEWDSK ;CONTINUATION TEST?
BVC MAINC ;YES, DO NOT ZERO LOG.
;
JSR WLOG ;WRITE ZEROED LOG.
;
MAINC LDA #MAXTRK ;START INWARDS
STA LIMIT
LDY #0
STY TRACK ;BASE TRACK IS 0
;
JSR PASS ;DO INWARDS PASS.
;
LDA FPASS ;CHECK FOR FIRST PASS
BEQ MAINA ;TO MAINA IF NOT
;
LDA #0 ;1ST PASS, RESET FIRST PASS FLAG
STA FPASS ;AND CHECK FOR 1ST PASS ERRORS
STA NEWDSK
;
LDA #5
CMP BADFPC
BCS MAINA ;IS OK
;
LDX #2 ;FIRST PASS FAILURE.
JMP BLINK ;BLINK FOREVER.
;
MAINA JSR PASCHK ;CHECK PASS COUNT
;
;
;
LDA #$FF ;GO TO MAXTRK AND START OUTWARDS
STA LIMIT
LDA #MAXTRK-1
STA TRACK ;BASE IS LAST-1
;
JSR PASS ;DO OUTWARDS PASS.
;
JSR PASCHK ;CHECK PASS COUNT
;
;
;
JMP MAINC ;CONTINUE TILL ENDED (IN PASCHK)
.PAGE 'PASS'
; ********************
; *                  *
; *       PASS       *
; *                  *
; ********************
;
PASS JSR RLOG ;GET LOG
;
BIT NEWDSK ;CHECK FOR OLD DISK.
BMI PASSC ;BIT7=1: 1ST PASS & JUST FMTD.
LDX PASTYP ;CHK PASTYP: IF + DO 1WR & N RD.
BMI PASSA ;IS FIXED READ OR WRITE.
DEC PASWRT ;VARIABLE, DEC COUNT OF READS.
LDX #READ ;PRESUME NEXT IS ALSO READ.
LDA PASWRT ;ON MODULO 'PASTYP', DO WRT.
BPL PASSA ;NOT YET, STILL READ.
LDA PASTYP ;NOW IS WRITE TIME.  RESET CNTR.
STA PASWRT
PASSC LDX #WRITE ;SET FOR WRITE PASS.
PASSA STX OPRTYP
.PAGE 'TEST'
; ***  TEST  ***
;
;
;
TEST LDA TRACK ;COPY BASE
STA CTRACK
;
TEST1 LDA CTRACK ;CURRENT TRACK.
BIT RNDTRK ;RANDOM TRACKS?
BPL TSTA ;NO, SEQUENTIAL.
TAX ;YES
LDA TRKTBL,X ;GET TRACK FROM TABLE.
TSTA STA TMPTRK ;SAVE ACTUAL TRACK.
CMP #40 ;SIDE 1 ?
BCC TSTB ;NO, BRANCH
PHP
SBC #40
PLP
TSTB STA CMDBUF+3 ;TRACK
STA CMDTRK
LDA #0
BCC TSTC ;BRANCH IF SIDE 0
LDA #%00010000 ;SIDE 1 FLG
TSTC STA SWITCH
;
LDA #14 ;MAX SECTOR
STA CMDBUF+4
STA SECTR
;
JSR STMTR ;START MOTOR
JSR SEKE ;SEEK
JSR WTMTR ;WAIT MOTOR
JSR SELSID ;SELECT SIDE
JSR SLOG ;SEEK LOGICAL
;
TSTD JSR QUE ;FIRE OFF THIS JOB
;
LDA MFMCMD ;GET STATUS
CMP #2 ;DONE, IS OK?
BCC TSTX ;YUP, TO TSTX
;
JSR RETRY ;NOPE, SEE IF CAN BE RECOVERED
.PAGE
TAX ;BACK FROM RECOVERY ATTEMPTS
INC ERRTYP,X ;INC TYPE OF ORIGINAL ERROR
BNE TSTF ;LIMITED TO 255
DEC ERRTYP,X
TSTF INC TOTERR ;UPDATE TOTAL ERROR COUNT
BNE TSTG
INC TOTERR+1
LDA TOTERR+1 ;CHECK # ERRORS
CMP #ERRLIM ;LIMIT=(#ERRLIM)*256
BNE TSTG ;OK
LDA #1 ;AT LIMIT OF ERRORS, STOP TEST.
STA NUMPAS
;
TSTG LDX TMPTRK ;UPDATE ERRORS ON THIS TRACK
INC TRKERR,X
BNE TSTH ;LIMITED TO 255
DEC TRKERR,X
;
TSTH LDX PAS100 ;INC ERRORS/100 PASSES.
INC ERRTIM,X
BNE TSTX ;LIMITED TO 255
DEC ERRTIM,X
;
;
;
TSTX DEC CMDBUF+4 ;SECTOR UPDATE
BPL TSTD ;NOT ALL YET
;
;
;
JSR TRNOFF ;TURN OFF MOTOR
;
INC CTRACK ;PRESUME GOING INWARDS
LDA LIMIT
BPL TSTY ;0=OUTWARD BOUND
DEC CTRACK ;1=INWARD BOUND
DEC CTRACK
;
TSTY CMP CTRACK ;END? (ACC)=LIMIT
BEQ UPLOG ;YES, UPDATE LOG AND LEAVE
JMP TEST1 ;NOT YET, DO NEXT TRACK
.PAGE 'LOG'
; ***  UPDATE LOG  ***
;
UPLOG INC TOTPAS ;INCREMENT TOTAL PASSES
BNE UPLB
INC TOTPAS+1
;
UPLB INC PASCNT ;UPDATE # OF PASSES (MODULO 100)
LDA #100
CMP PASCNT
BNE WLOG ;NOT 100 YET.
LDA #0
STA PASCNT
INC PAS100 ;MODULO 100 PASS COUNT
;
;
;
; ***  WRITE LOG  ***
;
WLOG
LDA #WRITE
ORA #$40 ;SET LOG BIT
STA OPRTYP
JMP LOG
.PAGE
; ***  READ LOG  ***
;
RLOG
LDA #READ
ORA #$40 ;SET LOG BIT
STA OPRTYP
;
;
;
; ***  LOG SUB  ***
;
LOG
LDX #LOGSEC
LDY #LOGTRK
STX CMDBUF+4 ;SECTOR
STX SECTR
STY CMDBUF+3 ;TRACK
STY CMDTRK
;
LDA #0 ;SIDE 0
STA SWITCH
;
JSR STMTR ;START MOTOR
JSR SEKE ;SEEK
JSR WTMTR ;WAIT MOTOR
JSR SELSID ;SELECT SIDE
JSR SLOG ;SEEK LOGICAL
;
LDY #10 ;ERROR COUNTER
STY WK3
;
;
;
LOGA JSR QUE ;START OPERATION
;
LDA MFMCMD
CMP #2 ;OK?
BCC LOGB ;YUP
DEC WK3 ;NO, ANOTHER TRY?
BNE LOGA ;YUP
;
LDX #3 ;POST LOG ACCESS FAILURE.
JMP BLINK
;
;
;
LOGB JSR TRNOFF ;TURN OFF MOTOR
RTS
.PAGE 'RETRY'
; ********************
; *      RETRY       *
; ********************
;
;RETRY ATTEMPTS JOB AGAIN, UP TO TEN TIMES.
;
;IF THIS IS FIRST PASS (READ), # OF RETRIES IS
;RECORDED IN BADCNT.  IF FIRST PASS RETRIES
;EXCEED 5 THEN TEST IS ABORTED.
;
;
RETRY STA WK1 ;SAVE ORIGINAL ERROR TYPE
;
LDX #0 ;RECOVERY TIME POINTER
STX WK3
;
RTA INC WK3
;
JSR QUE ;RETRY JOB
;
LDA MFMCMD ;GET STATUS
CMP #2 ;DONE. OK NOW?
BCC RTC ;YES, TO RTC
LDA WK3 ;NO, TEN RETRIES YET?
CMP #10
BCC RTA ;NO, TRY AGAIN
;
RTC DEC WK3 ;NORMALIZE RETRY COUNT TO 0-9.
LDX WK3
LDA FPASS ;SPECIAL RECORDING IF 1ST PASS
BEQ RTF
;
TXA ;DURING FIRST PASS, RECORD
CLC ;# OF ERRORS BEYOND 1ST RETRY.
ADC BADFPC ;ERROR COUNT FOR END OF 1STPASS
STA BADFPC
;
LDY TMPTRK ;ACTUAL TRACK IN TEST.
TXA
CLC
ADC FPCARY,Y
STA FPCARY,Y
;
RTF INC REVCNT,X ;UPDATE #RETRIES ARRAY
BNE RTX ;LIMITED TO 255
DEC REVCNT,X
;
RTX LDA WK1 ;RETRIEVE ORIGINAL ERROR
RTS
.PAGE 'PASCHK'
; ********************
; *                  *
; *    PASS CHECK    *
; *                  *
; ********************
;
PASCHK LDA NUMPAS ;CHECK FOR LAST PASS
BEQ PASSW ;IF STORED 0, WILL DO FOREVER.
CMP #11 ;CHECK FOR 2N PASS COUNT.
BCC PASSY ;TO PASSY IF <11 PASSES
LDA PASALT ;>11 IS 2 PASS/COUNT.
EOR #1
STA PASALT
BNE PASSZ ;ON ALT PASS.
PASSY DEC NUMPAS
BEQ PASSX ;DONE, GO BLINK.
PASSZ LDA NUMPAS ;NOT YET DONE, CHECK FOR PURE
AND #1 ;TRK SEQNCE AT ODD PASS COUNT.
BEQ PASSR ;EVEN COUNT.
PASSW BIT RNDTRK ;PURE SEQUENCE IF BIT6=0.
BVC PASSR ;BIT6=0 (OVF=0). PURE.
LDA RNDTRK ;ALTERNATE RANDOM/SEQUENTIAL
EOR #$80 ;TRACK SEQUENCE.
STA RNDTRK
PASSR RTS
;
PASSX LDX #1 ;BLINK LED ONCE.
JMP BLINK ;FOREVER
.PAGE 'PRCMD2'
; ********************
; *       JOB        *
; ********************
;
;
QUE
LDA OPRTYP
AND #$3F ;CLEAR LOG BIT
CMP #WRITE
BEQ WCMD
;
JSR CMDNIN ;READ
JMP RNEXT
;
WCMD JSR CMDTEN ;WRITE
;
RNEXT RTS
.PAGE 'READ'
; ********************
; *       READ       *
; ********************
 ;COMMAND NINE
CMDNIN ;READ
LDY #0
;
LDA CMDBUF+3
STA WDTRK
LDA CMDBUF+4
STA WDSEC
;
LDA #$88 ;READ SECTOR COMMAND
JSR STRTWD ;SEND COMMAND
;
C900 LDA WDSTAT ;GET STATUS
AND #3
LSR A
BCC C902
;
AND #1
BEQ C900
;
LDA WDDAT ;GET DATA
;
BIT OPRTYP ;LOG ?
BVC RSKIP1 ; NO, BRANCH
STA BUFL,Y ;STORE LOG BUFFER
;
RSKIP1 INY
BNE C900
;
C902 JSR WAITDN ;WAIT FOR UNBUSY
;
JSR CVSTAT ;CONVERT STATUS
;
RTS
.PAGE 'CMDTEN'
; ********************
; *      WRITE       *
; ********************
 ;COMMAND TEN
CMDTEN ;WRITE
LDY #0
;
LDA CMDBUF+3 ;TRACK
STA WDTRK
;
LDA CMDBUF+4 ;SECTOR
STA WDSEC
;
LDA #$A8 ;NORMAL DAM
JSR STRTWD ;SEND COMMAND
;
CMD10 LDA WDSTAT ;GET STATUS
AND #3
LSR A
BCC C110
;
AND #1
BEQ CMD10
;
LDA PATERN ;GET PATTERN
;
BIT OPRTYP ;LOG ?
BVC WSKIP1 ;NO, BRANCH
LDA BUFL,Y ;GET LOG
;
WSKIP1 STA WDDAT ;PUT TO WD
;
INY
BNE CMD10
;
;
;
JSR CMDELE ;VERIFY
BCS C111
;
C110 JSR CVSTAT ;CONVERT STATUS
;
C111 RTS
.PAGE 'CMDELE'
; ********************
; *      VERIFY      *
; ********************
 ;COMMAND ELEVEN
CMDELE ;VERIFY
LDY #0
;
LDA CMDBUF+3 ;TRACK
STA WDTRK
;
LDA CMDBUF+4 ;SECTOR
STA WDSEC
;
LDA #$88 ;READ SECTOR
JSR STRTWD ;SEND COMMAND
;
C1100 LDA WDSTAT
AND #3
LSR A
BCC C1101
;
AND #1
BEQ C1100
;
LDA WDDAT ;GET BYTE
;
BIT OPRTYP ;LOG ?
BVC VSKIP1 ;NO, BRANCH
;
CMP BUFL,Y
BNE C1101
BEQ VSKIP2
;
VSKIP1 CMP PATERN
BNE C1101
;
VSKIP2 INY
BNE C1100 ;NOT YET
BEQ C1104 ;OK, EXIT
;
;
;
C1101 LDA #$D0 ;ABORT WD
STA WDSTAT
;
JSR JSLOWD ;WAIT 40 USEC
;
LDX #7 ;VERIFY ERROR
.BYTE $2C
;
C1104 LDX #0
STX MFMCMD
;
JMP WAITDN ;WAIT FOR UNBUSY & RETURN
.PAGE 'SUB'
; ***  BLINK  ***
;
BLINK STX WK2 ;BLINK ROUTINE.
JSR BUMPIT ;BUMP DRIVE.
BIT RESET ;RESET SYSTEM?
BMI ENDIT ;YES.
BLNA LDX WK2
STX WK1
;
BLNB JSR LEDON ;SET LED ON.
JSR LEDOFF ;SET LED OFF.
DEC WK1
BNE BLNB
JSR WINK ;LONG OFF DELAY.
JSR WINK ;LONG OFF DELAY.
JMP BLNA ;FOREVER AND EVER, AMEN...
;
;
;
LEDON LDA #LED ;SET LED ON.
ORA LEDPRT
BNE WAIT
;
LEDOFF LDA #$FF-LED ;SET LED OFF.
AND LEDPRT
WAIT LDX #128 ;MEDIUM DELAY.
WAITX STA LEDPRT ;UPDATE LED.
WAITY LDY #0
WINK ADC #0 ;LONG DELAY IF ENTERED HERE.
ADC #0
DEY
BNE WINK
DEX
BNE WINK
RTS
;
;
;
ENDIT JSR WAITY
JSR WAITY
JMP ($FFFC)
.PAGE
; ***  BUMP  ***
;
BUMPIT JSR STMTR ;START MOTOR
JSR WTMTR ;WAIT MOTOR
JSR CMDONE ;BUMP DRIVE
JSR TRNOFF ;TURN OFF MOTOR
RTS
;
;
;
; ***  FILL  ***
;
FILRUP LDY #0
TYA
FILB STA BUFL,Y ; FILL 0
INY
BNE FILB ;DO FULL PAGE.
RTS ;DONE.
.PAGE 'TABLE'
; ***  WORK STORES  ***
;
OPRTYP *=*+1 ;CURRENT OPERATION
TRACK *=*+1 ;BASE TRACK
CTRACK *=*+1 ;CURRENT TRACK
LIMIT *=*+1 ;END TRACK OF TEST
FPASS *=*+1 ;FIRST PASS FLAG
PASALT *=*+1 ;ALT FLAG FOR 2N PASSES
PASWRT *=*+1 ;COUNTER FOR WRITE PASSES.
TMPTRK *=*+1 ;#TRACK STORE TEMP
;
;
;
; ********************
; *   TRACK TABLE    *
; ********************
;
TRKTBL
 .BYTE 10,60,16,40,01,50,39,44,21,63,12,46,07,53
 .BYTE 28,78,05,75,32,51,22,55,17,43,14,71,02,59
 .BYTE 27,73,36,49,24,77,25,59,34,48,26,58,08,56
 .BYTE 18,74,29,65,37,64,09,76,33,57,19,42,31,54
 .BYTE 03,47,15,62,11,72,35,45,38,68,13,47,06,52
 .BYTE 23,61,04,79,30,41,00,56,20,50
 .END
